/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-04-22 16:30:03 UTC)
 * on 2013-04-22 at 17:23:40 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

/**
 * Current state of a job.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobState extends com.google.api.client.json.GenericJson {

  /**
   * Email address of the assignee.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String assignee;

  /**
   * Custom fields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private CustomFields customFields;

  /**
   * Customer name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customerName;

  /**
   * Customer phone number.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customerPhoneNumber;

  /**
   * Identifies this object as a job state.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Job location.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Location location;

  /**
   * Note added to the job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> note;

  /**
   * Job progress.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String progress;

  /**
   * Job title.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Email address of the assignee.
   * @return value or {@code null} for none
   */
  public java.lang.String getAssignee() {
    return assignee;
  }

  /**
   * Email address of the assignee.
   * @param assignee assignee or {@code null} for none
   */
  public JobState setAssignee(java.lang.String assignee) {
    this.assignee = assignee;
    return this;
  }

  /**
   * Custom fields.
   * @return value or {@code null} for none
   */
  public CustomFields getCustomFields() {
    return customFields;
  }

  /**
   * Custom fields.
   * @param customFields customFields or {@code null} for none
   */
  public JobState setCustomFields(CustomFields customFields) {
    this.customFields = customFields;
    return this;
  }

  /**
   * Customer name.
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomerName() {
    return customerName;
  }

  /**
   * Customer name.
   * @param customerName customerName or {@code null} for none
   */
  public JobState setCustomerName(java.lang.String customerName) {
    this.customerName = customerName;
    return this;
  }

  /**
   * Customer phone number.
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomerPhoneNumber() {
    return customerPhoneNumber;
  }

  /**
   * Customer phone number.
   * @param customerPhoneNumber customerPhoneNumber or {@code null} for none
   */
  public JobState setCustomerPhoneNumber(java.lang.String customerPhoneNumber) {
    this.customerPhoneNumber = customerPhoneNumber;
    return this;
  }

  /**
   * Identifies this object as a job state.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a job state.
   * @param kind kind or {@code null} for none
   */
  public JobState setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Job location.
   * @return value or {@code null} for none
   */
  public Location getLocation() {
    return location;
  }

  /**
   * Job location.
   * @param location location or {@code null} for none
   */
  public JobState setLocation(Location location) {
    this.location = location;
    return this;
  }

  /**
   * Note added to the job.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getNote() {
    return note;
  }

  /**
   * Note added to the job.
   * @param note note or {@code null} for none
   */
  public JobState setNote(java.util.List<java.lang.String> note) {
    this.note = note;
    return this;
  }

  /**
   * Job progress.
   * @return value or {@code null} for none
   */
  public java.lang.String getProgress() {
    return progress;
  }

  /**
   * Job progress.
   * @param progress progress or {@code null} for none
   */
  public JobState setProgress(java.lang.String progress) {
    this.progress = progress;
    return this;
  }

  /**
   * Job title.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Job title.
   * @param title title or {@code null} for none
   */
  public JobState setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public JobState set(String fieldName, Object value) {
    return (JobState) super.set(fieldName, value);
  }

  @Override
  public JobState clone() {
    return (JobState) super.clone();
  }

}
